#include <stdio.h>
#include <stdbool.h>
#include <assert.h>
#include <time.h>

/* O(n^3) */

#define Assert assert
#define verbose false

#define MaxW 1000000000
#define MaxH 1000000000
#define MaxN 300

int Primerjaj(const void *a, const void *b) {
	return *(const int *) a - *(const int *) b; }

int UrediInOdstraniDuplikate(int *p, int n)
{
	int i, m;
	qsort(p, n, sizeof(int), &Primerjaj);
	for (i = 0, m = 0; i < n; i++)
		if (m == 0 || p[i] != p[m - 1]) p[m++] = p[i];
	return m;
}

typedef struct { int x1, y1, x2, y2; } Rect;

int w, h, n, y0;
int xs[2 * MaxN + 2], ys[2 * MaxN + 1], nxs, nys;
long long naj[2][2 * MaxN + 1]; bool vod[2 * MaxN + 1], nav[2 * MaxN];
Rect ast[MaxN];

bool JePotProsta(int x1, int y1, int x2, int y2)
{
	int i;
	if (y2 < y1) i = y1, y1 = y2, y2 = y1;
	if (x2 < x1) i = x1, x1 = x2, x2 = x1;
	for (i = 0; i < n; i++)
		if (x2 >= ast[i].x1 && x1 <= ast[i].x2 &&
			y2 >= ast[i].y1 && y1 <= ast[i].y2) return false;
	return true;
}

int main(int argc, char** argv)
{
	int ok_, i, ix, iy, iyPrej, x, xPrej, smer; long long kand, najKand, *najPrej;
	clock_t tm = clock();
	FILE *f = fopen(argc > 1 ? argv[1] : "asteroidi.in", "rt");
	ok_ = fscanf(f, "%d %d %d %d", &h, &w, &y0, &n);
	Assert(ok_ == 4);
	Assert(1 <= w); Assert(w <= MaxW);
	Assert(1 <= h); Assert(h <= MaxH);
	Assert(0 <= y0); Assert(y0 < h);
	Assert(1 <= n); Assert(n <= MaxN);
	for (i = 0, nxs = 0, nys = 0; i < n; i++)
	{
		ok_ = fscanf(f, "%d %d %d %d", &ast[i].x1, &ast[i].y1, &ast[i].x2, &ast[i].y2);
		Assert(ok_ == 4);
		Assert(0 <= ast[i].x1); Assert(ast[i].x1 <= ast[i].x2); Assert(ast[i].x2 < w);
		Assert(0 <= ast[i].y1); Assert(ast[i].y1 <= ast[i].y2); Assert(ast[i].y2 < h);
		if (ast[i].x1 > 0) xs[nxs++] = ast[i].x1 - 1; if (ast[i].x2 < w - 1) xs[nxs++] = ast[i].x2 + 1;
		if (ast[i].y1 > 0) ys[nys++] = ast[i].y1 - 1; if (ast[i].y2 < h - 1) ys[nys++] = ast[i].y2 + 1;
	}
	fclose(f);
	xs[nxs++] = 0; xs[nxs++] = w - 1; ys[nys++] = y0;
	nxs = UrediInOdstraniDuplikate(xs, nxs);
	nys = UrediInOdstraniDuplikate(ys, nys);
	if (verbose) printf("nxs = %d, nys = %d\n", nxs, nys);
	for (iy = 0; iy < nys; iy++) naj[1][iy] = (ys[iy] == y0) ? 0 : -1;
	for (ix = 0, x = -1; ix < nxs; ix++)
	{
		xPrej = x; x = xs[ix];
		najPrej = naj[(ix + 1) % 2];
		/* Poglejmo, kje je mogoe narediti premik vodoravno iz
		   (xPrej, ys[iy]) v (x, ys[iy]). */
		for (iy = 0; iy < nys; iy++) vod[iy] = JePotProsta(xPrej, ys[iy], x, ys[iy]);
		/* Poglejmo, kje je mogoe narediti premik navpino med
		   (x, ys[iy]) in (x, ys[iy + 1]). */
		for (iy = 0; iy < nys - 1; iy++) nav[iy] = JePotProsta(x, ys[iy], x, ys[iy + 1]);
		/* Za vsako polje v tem stolpcu doloimo najkrajo pot. */
		for (iy = 0; iy < nys; iy++)
		{
			najKand = vod[iy] ? najPrej[iy] : -1;
			for (smer = -1; smer <= 1; smer++) if (smer != 0)
				for (iyPrej = iy + smer; 0 <= iyPrej && iyPrej < nys; iyPrej += smer)
				{
					/* Ali bi bil navpini premik iz (x, ys[iyPrej]) proti (x, ys[iy]) sploh mogo? */
					if (! (smer > 0 ? nav[iyPrej - 1] : nav[iyPrej])) break;
					if (false) printf("iyPrej = %d (%d), vod = %b\n", iyPrej, ys[iyPrej], vod[iyPrej]);
					/* Ali je mogo vodoravni premik iz (xPrej, ys[iyPrej]) v (x, ys[iyPrej])? */
					if (! vod[iyPrej]) continue;
					kand = najPrej[iyPrej]; if (kand < 0) continue;
					kand += (smer > 0) ? ys[iyPrej] - ys[iy] : ys[iy] - ys[iyPrej];
					if (verbose) printf("- - cez (%d, %d) [%d] v (%d, %d): kand = %d\n", x, ys[iyPrej], najPrej[iyPrej], x, ys[iy], kand);
					if (najKand < 0 || kand < najKand) najKand = kand;
				}
			naj[ix % 2][iy] = najKand;
			if (verbose) printf("- Naj(%d, %d) - %d\n", xs[ix], ys[iy], naj[ix % 2][iy]);
			if (false && xs[ix] == 7 && ys[iy] == 8) return 1;
		}
	}
	/* Izpiimo najbolji rezultat. */
	for (najKand = -1, iy = 0; iy < nys; iy++) {
		kand = naj[(nxs - 1) % 2][iy];
		if (kand >= 0 && (najKand < 0 || kand < najKand)) najKand = kand; }
	printf("w = %d, h = %d, n = %d: resitev O(n^3) porabi %.3f s.\n", w, h, n, (clock() - tm) / ((double) CLOCKS_PER_SEC));
	f = fopen(argc > 2 ? argv[2] : "asteroidi.out", "wt");
	fprintf(f, "%lld\n", najKand); fclose(f); return 0;
}