#include <stdio.h>
#include <stdlib.h>
#include <stdbool.h>
#include <assert.h>
#include <time.h>

#define MaxM 50
#define MaxN 7500

#define verbose false
#define Assert assert

typedef struct { int otrok[2], list; } Vozlisce;
Vozlisce *vozl;
int koren, nVozlisc, n, m, prvi;
char nizi[MaxN][MaxM + 3];
int listi[MaxN], naj[MaxM];

bool Rekurzija(int u, int v, int globina, bool jeNaj)
{
	int pb, prejNajBit; bool ok, prejJeNaj;

if (verbose) { printf("Rekurzija u = %d, v = %d, globina %d, jeNaj = %s: ", u, v, globina, jeNaj ? "true" : "false");
	for (pb = 0; pb < globina; pb++) printf("%d", naj[pb]); printf("\n"); }

	if (u < 0 || v < 0) return false;
	if (globina == m)
		if (u == v) return vozl[u].list >= 2;
		else return vozl[u].list >= 1 && vozl[v].list >= 1;

	pb = nizi[prvi][globina];
	ok = false;
	/* Poskusimo najprej nadaljevati pot tako, da bo imel xor vseh
	   treh planetov na tem mestu prigan bit. */
	prejJeNaj = jeNaj; prejNajBit = naj[globina];
	if (! jeNaj && naj[globina] == 0) jeNaj = true;
	naj[globina] = 1;
if (verbose) printf("(u = %d, v = %d: jeNaj = %s, prejNajBit = %d -> %d, pb = %d\n", u, v, jeNaj ? "true" : "false", prejNajBit, naj[globina], pb);
	if (Rekurzija(vozl[u].otrok[0], vozl[v].otrok[pb ^ 1], globina + 1, jeNaj)) ok = true, jeNaj = false;
	if (u != v || pb == 1) if (Rekurzija(vozl[u].otrok[1], vozl[v].otrok[pb], globina + 1, jeNaj)) ok = true;
	if (ok) return true;
	jeNaj = prejJeNaj; naj[globina] = prejNajBit;
	/* e to ni mogoe, poskusimo nadaljevati tako, da bo imel xor vseh
	   treh planetov na tem mestu ugasnjen bit.  To nadaljevanje pa nima
	   smisla, e e poznamo neko drugo reitev, ki se na vijih bitih ujema z
	   nao, na trenutnem mestu pa ima prigan bit. */
	if (jeNaj) naj[globina] = 0;
	else if (naj[globina] == 1) return false;
if (verbose) printf("((u = %d, v = %d\n", u, v);
	if (Rekurzija(vozl[u].otrok[0], vozl[v].otrok[pb], globina + 1, jeNaj)) ok = true, jeNaj = false;
	if (u != v || pb == 0) if (Rekurzija(vozl[u].otrok[1], vozl[v].otrok[pb ^ 1], globina + 1, jeNaj)) ok = true;
	if (ok) return true;
	naj[globina] = prejNajBit; return false;
}

int main(int argc, char** argv)
{
	int ok_, i, j, tren, b;
	clock_t tm;
	FILE *f;

	tm = clock();
	/* Preberimo n in m. */
	f = fopen((argc > 1) ? argv[1] : "xor.in", "rt");
	ok_ = fscanf(f, "%d %d\n", &n, &m);
	Assert(ok_ == 2); Assert(3 <= n); Assert(n <= MaxN);
	Assert(1 <= m); Assert(m <= MaxM);
	/* Pripravimo tabelo za vozlia drevesa in ustvarimo koren. */
	vozl = (Vozlisce *) malloc(sizeof(Vozlisce) * m * n);
	koren = 0; nVozlisc = 1;
	vozl[koren].otrok[0] = -1; vozl[koren].otrok[1] = -1; vozl[koren].list = 0;
	/* Preberimo vseh n nizov in jih dodajmo v drevo. */
	for (i = 0; i < n; i++) {
		fgets(nizi[i], sizeof(nizi[i]), f);
		tren = koren;
		for (j = 0; j < m; j++)
		{
			Assert(nizi[i][j] == '0' || nizi[i][j] == '1');
			b = nizi[i][j] -= '0';
			/* e e ni otroka, v katerem moramo nadaljevati pot po drevesu, ga zdaj ustvarimo. */
			if (vozl[tren].otrok[b] < 0) {
				vozl[nVozlisc].otrok[0] = -1; vozl[nVozlisc].otrok[1] = -1;
				vozl[nVozlisc].list = 0; vozl[tren].otrok[b] = nVozlisc++; }
			/* Premaknimo se v otroka, ki ustreza trenutnemu bitu naega niza. */
			tren = vozl[tren].otrok[b];
		}
		/* Zapomnimo si, da je trenutno vozlie list. */
		vozl[tren].list++; listi[i] = tren;
if (verbose) printf("list %d\n", tren);
		Assert(nizi[i][m] == 0 || nizi[i][m] == '\n'); }
	fclose(f);

	/* Za vsak moen izbor prvega planeta izberimo ostala dva tako,
	   da bosta dala skupaj s prvim im veji xor vseh treh nizov. */
	for (j = 0; j < m; j++)	naj[j] = 0;
	for (prvi = 0; prvi < n; prvi++) {
		vozl[listi[prvi]].list--;
if (verbose) printf("---- prvi = %d\n", prvi);
		Rekurzija(koren, koren, 0, false);
		vozl[listi[prvi]].list++; }

	printf("Ucinkovita resitev: n = %d, m = %d -> %.2f s\n", n, m, (clock() - tm) / ((double) CLOCKS_PER_SEC))	;

	/* Izpiimo rezultate. */
	f = fopen((argc > 2) ? argv[2] : "xor.out", "wt");
	for (j = 0; j < m; j++) fputc('0' + naj[j], f);
	fclose(f); free(vozl); return 0;
}
